

require 'disjunction_class'
require 'rule'


class RewriterHead

  attr :nfn_head
  attr :dlp_head
  attr :std_rules_chr
  
  
  def initialize(head)
    @nfn_head = head
    @dlp_head = Disjunction.new([])
    @std_rules_chr = []
  end
  
  
  def rewrite_head(number_rule)
    i = 1
    @nfn_head.each do |bc|
      if bc.size == 1 then
	@dlp_head.add(bc.to_atom)
      else
	terms = Terms.new([])
	bc.each do |a|
	  terms = terms + a.getTerms
        end
	
        terms = terms.deleteDuplicates
        pred = "auxh" + i.to_s + "_" + number_rule.to_s
        aux = Atom.new(pred,terms)
	
	# builds auxilary rules to define 
        # the auxiliry predicate 
	bc.each do |a|
	  aux_r = Rule.new(a,aux)
	  @std_rules_chr = @std_rules_chr + [aux_r.to_s]
        end
	@std_rules_chr = @std_rules_chr + [Rule.new(aux,bc).to_s]
	
	@dlp_head.add([aux])
        i+=1
      end      
    end
  end
  
end









