
require 'set'

class Term
 attr :term

 def initialize(t)
    @term = t
 end

 def isConst
   if @term != "_"
     is_int = @term.to_i
       if  is_int > 0
         return true
       else
	 if is_int == 0 
           if @term == "0"
	     return true
           else
             temp = @term[0].chr
             if @term[0].chr == temp.downcase
               return true
	     end
           end
         end
       end
    end
   return false
 end

 def isAnonVar
    return @term == "_"
 end
 
 def isVar
    return (!isConst && !isAnonVar)
 end

 def to_s
    @term.to_s
 end

 def ==(t)
    return @term == t.term
 end
end



class Terms

  attr :termsA

  def initialize(t)
    @termsA = t
  end


  def size
     return to_a.size
  end

  def -(ts)
     a1 = Array.new
     a2 = Array.new
     t = Terms.new([])
     @termsA.each do |v|
       a1.push(v.to_s)
     end
     ts.termsA.each do |v2|
       a2.push(v2.to_s)
     end
     s = a1 - a2
     s.each do |v3|
        t.push(Term.new(v3))
     end
     return t
  end

  def sort
      @termsA.sort do |t1,t2|
        t1.term <=> t2.term
      end
      return self
  end

  def deleteDuplicates
     a1 = Array.new
     t = Terms.new([])
     @termsA.each do |v|
       a1.push(v.to_s)
     end
     s = Set.new(a1)
     s.to_a.each do |v3|
        t.push(Term.new(v3))
     end
     @termsA = t
     return self
  end

  def +(ts)
     s = self.to_a + ts.to_a
     t = Terms.new([])
     s.to_a.each do |v3|
        t.push(Term.new(v3))
     end
     return t
  end

  def &(ts)
     a1 = Array.new
     a2 = Array.new
     t = Terms.new([])
     @termsA.each do |v|
       a1.push(v.to_s)
     end
     ts.termsA.each do |v2|
       a2.push(v2.to_s)
     end
     inters = a1 & a2
     
     inters.each do |v3|
        t.push(Term.new(v3))
     end
     return t
  end

  def to_s
     str = String.new( @termsA[0].to_s)
     for n in  1 .. (@termsA.size - 1)
        str = str + "," +  @termsA[n].to_s
     end
    return str
  end

  def join(s)
     return @termsA.join(s)
  end

  def push(t)
     @termsA.push(t)
  end

  def [](i)
     return @termsA[i]
  end

  def set_term(i,t)
     a = self.to_a
     a[i] = t.to_s
     t = Terms.new([])
     a.each do |v|
       t.push(Term.new(v))
     end
    @termsA = t.termsA
  end

  def each
      @termsA.each {|a| yield a}
  end

  def to_a
     a1 = Array.new
     @termsA.each do |v|
       a1.push(v.to_s)
     end
    return a1
  end

  def index(t)
     return @termsA.index(t)
  end

  def empty?
     a1 = Array.new

     @termsA.each do |v|
       a1.push(v.to_s)
     end
     return a1.empty?
  end

  def include?(t)
     return @termsA.include?(t)
  end
 
  def ==(ts)
    if (@termsA.size != ts.termsA.size)
      return false
    end
    for n in  0 .. (@termsA.size - 1)
      if !(@termsA[n] == ts[n])
	return false;
      end
    end
   return true
  end
end


