
require 'term_class'
class Atom
  
  attr :predicate_name
  attr :terms
  
  def initialize(name, terms)
    @predicate_name = name
    @terms = terms
  end
  
  def getPred
    return @predicate_name
  end
  
  def getTerms
    return @terms
  end
  
  def to_s 
    if @terms.size == 0 then
      @predicate_name.to_s 
    else
      @predicate_name.to_s + "(" + @terms.to_s + ")"
    end
  end
  
  def getVars
    vars = Terms.new([])
    @terms.each do |term|
      if term.isVar == true
        vars.push(term)
      end
    end
    return vars
  end

  def size
    return 1
  end

  def includeAnonVars?
    @terms.each do |t|
      if t.isAnonVar == true
	return true
      end
    end
    return false
  end
   
  def ==(a)
    if (a.predicate_name == @predicate_name)
      if (a.terms.to_s == @terms.to_s)
	return true
      end
    end

    return false
  end 

 def <=>(a)
   if (@predicate_name <=> a.predicate_name)== +1
      puts @predicate_name 
      puts "> dell'altro" 
      return +1
   end

   if (@predicate_name <=> a.predicate_name)== -1
      puts @predicate_name 
      puts "< dell'altro" 

     return -1
   end

   if  (@predicate_name <=> a.predicate_name)== 0
      return (a.terms.to_s <=> @terms.to_s)
   end

 end


 def copy
   pred = String.new(@predicate_name)
   term = Terms.new(@terms)
   return Atom.new(pred, term)
 end
end

