

require 'basic_conjunction_class'

class Disjunction

  attr :disj

  def initialize(disj)
     @disj = disj
  end

  def each 
    @disj.each {|d| yield d}
  end

  def to_s
     if @disj.size == 0 then
        return ""
     end

     str = String.new
     for n in  1 .. (@disj.length - 1)
          if @disj[n-1].size == 1 then
              str = str +  @disj[n-1].to_s + " v "
          else
              str = str + "(" + @disj[n-1].to_s + ")" + " v "
         end
     end   
    if @disj[@disj.length-1].size == 1 then
       str = str +  @disj[@disj.length-1].to_s 
    else
       str = str + "(" + @disj[@disj.length-1].to_s + ")"
    end
     return str
  end
  
  def add(basic_conjunction)
      @disj.push(basic_conjunction)
  end 

  def size
      @disj.size
  end

  def vars_disj
      vars = Terms.new([])
      @disj.each do |bc|
         bc.each do |a|
	    vars = vars + a.getVars
         end
      end
      return vars.deleteDuplicates
  end

end
