
require 'atom_class'

class Literal 
   attr :isNeg
   attr :atom

   def initialize(isNeg, atom)
     @isNeg = isNeg     
     @atom = atom
   end
       
   def isNegative
      return isNeg == true;
   end

   def to_s
     if @isNeg == true then
       "not " + @atom.to_s
     else
       @atom.to_s
     end
   end
  
   def internal_atom
       return @atom
   end


   def size
       return 1
   end
   
   def safe_vars
     if @isNeg == false then
         return  @atom.terms
     else
         return Terms.new([])
     end
  end

  def ==(l)
     if l.isNeg == @isNeg && l.atom == @atom
        return true
     end
     return false
  end
  
end

