
require 'rewriter_head_class'
require 'rewriter_body_class'

class RewriterNFNrule
  
  attr :rule
  attr :std_rules_chr
  
  
  def initialize(rule)
    @rule = rule
    @std_rules_chr = []
  end
  
  def rewriteNFNrule(rule_number)
    rew_nfn_head = RewriterHead.new(@rule.head)
    rew_nfn_head.rewrite_head(rule_number)
    @std_rules_chr = @std_rules_chr + rew_nfn_head.std_rules_chr
    
    rew_nfn_body = RewriterBody.new(@rule.body)
    rew_nfn_body.rewrite_body(rule_number, @rule.head)
    @std_rules_chr = @std_rules_chr + rew_nfn_body.std_rules_chr
    
    @std_rules_chr = @std_rules_chr + [Rule.new(rew_nfn_head.dlp_head,
			      rew_nfn_body.dlp_body).to_s]
  end
end
